import java.util.HashMap;
import java.util.Map;

class Transaction{
    public String user;
    public int value;

    public Transaction (String user, int value) {
	this.user = user;
	this.value = value;
    }
}

public class BankAccount {
    int TRANSACTION_COUNT = 0;
    int current_balance;
    
    Map<Integer, Transaction> ledger;

    public BankAccount(int current_balance) {
	this.current_balance = current_balance;
	this.ledger = new HashMap<>();
    }

    public void updateLedger(String user, int amount) {
	ledger.put(++TRANSACTION_COUNT, new Transaction(user, amount));
    }

    public void deposit(String user, int amount) {
	current_balance += amount;
	updateLedger(user, amount);
    }

    public void withdraw(String user, int amount) {
	current_balance -= amount;
	updateLedger(user, -1 * amount);
    }
    
    public static void main(String[] args) {
	BankAccount account = new BankAccount(100);
	account.deposit("Nancy", 12);
	account.withdraw("Kwame", 120);
    }
}
