package edu.cornell;

public aspect BankAccountAspect {

    pointcut callWithDraw(String user, int amount, BankAccount account):
             call(void BankAccount.withdraw(String, int)) && args(user, amount) && target(account);

    before(String user, int amount, BankAccount account) : callWithDraw(user, amount, account) {
        System.out.println(String.format(" Balance before %s's attempted withdrawal: %d", user, account.current_balance));
        System.out.println(String.format(" Amount %s wants to withdraw: %d",  user, amount));
    }

    void around(String user, int amount, BankAccount account) : callWithDraw(user, amount, account) {
        if (account.current_balance < amount) {
            System.out.println(String.format(" Withdrawal Rejected! Reason: The %d amount %s wants to withdraw is greater than the current balance of %d.", amount, user, account.current_balance));
            return;
        }
        proceed(user, amount, account);
    }

    after(String user, int amount, BankAccount account) : callWithDraw(user, amount, account) {
        System.out.println("Balance after withdrawal : " + account.current_balance);
    }

    before(String user, int amount, BankAccount account) : call(void BankAccount.deposit(String, int)) && args(user, amount) && target(account) {
        System.out.println(String.format(" Balance before %s's deposit: %d", user, account.current_balance));
        System.out.println(String.format(" Amount %s wants to deposit: %d",  user, amount));
    }

    after(String user, int amount, BankAccount account) : call(void BankAccount.deposit(String, int)) && args(user, amount) && target(account) {
        System.out.println("Balance after deposit : " + account.current_balance);
    }
}